#if WINDOWS

using System;
using System.Runtime.InteropServices;

namespace Smdn.Applications.DirectoryAnalyzer.Util.Windows
{
  public partial class PlatformApi
  {
    [DllImport("shell32.dll", SetLastError = true, CharSet = CharSet.Auto, EntryPoint = "ExtractAssociatedIcon")]
    internal extern static IntPtr ExtractAssociatedIcon
        (
            IntPtr hInst,
            [MarshalAs(UnmanagedType.LPTStr)] string lpIconPath,
            ref int lpiIcon
        );

    [DllImport("shell32.dll", SetLastError = true, CharSet = CharSet.Auto, EntryPoint = "ExtractIcon")]
    internal extern static IntPtr ExtractIcon
        (
            IntPtr hInst,
            [MarshalAs(UnmanagedType.LPTStr)] string lpszExeFileName,
            int nIconIndex
        );

    [DllImport("shell32.dll", SetLastError = true, CharSet = CharSet.Auto, EntryPoint = "ExtractIconEx")]
    internal extern static int ExtractIconEx
        (
            [MarshalAs(UnmanagedType.LPTStr)] string lpszExeFileName,
            int nIconIndex,
            IntPtr[] phIconLarge,
            IntPtr[] phIconSmall,
            int nIcons
        );

    [DllImport("user32.dll", SetLastError = true, EntryPoint = "DestroyIcon")]
    [return: MarshalAs(UnmanagedType.Bool)]
    internal extern static bool DestroyIcon
        (
            IntPtr hIcon
        );
  }
}
#endif
